import React, { Component } from "react";

import Button from "../button/button";
import Input from "../input";

export default class Form extends Component {
	submit = e => {
		e.preventDefault();

		this.props.onSubmitEvent();
	};

	render() {
		const { values, onChangeEvent, reset, editableForm, addHobby, rmHobby } = this.props;

		return (
			<form onSubmit={this.submit}>
				<Input
					onChange={onChangeEvent}
					value={values.firstName}
					id="firstName"
					name="firstName"
					label="First Name"
				/>
				<Input
					onChange={onChangeEvent}
					value={values.lastName}
					id="lastName"
					name="lastName"
					label="Last Name"
				/>
				<Input onChange={onChangeEvent} value={values.age} id="age" type="number" name="age" label="Age" />
				<Input
					onChange={onChangeEvent}
					checked={values.editable}
					id="editable"
					type="checkbox"
					name="editable"
					label="Editable"
				/>
				<Button text="+" onClick={addHobby} />

				{values.hobby.map(el => (
					<div key={el.id}>
						<Input onChange={onChangeEvent} value={el.value} id={el.id} name="hobby" label="Hobby" />
						<Button text="-" onClick={rmHobby.bind(null, el.id)} />
					</div>
				))}

				<Button type="submit" text={editableForm ? "Save" : "Add"} />
				<Button text="Reset" onClick={reset} />
			</form>
		);
	}
}
